/**
 * 
 */
package com.gau.utils.net;

import com.gau.utils.net.request.THttpRequest;

/**
 * @author liguoliang
 * 
 */
public interface INetRecord {
	/**
	 * 开始连接
	 * 
	 * @param request
	 * @param arg1
	 *            保留参数
	 * @param arg2
	 *            保留参数
	 */
	void onStartConnect(THttpRequest request, Object arg1, Object arg2);

	/**
	 * 连接成功,准备接受数据
	 * 
	 * @param request
	 * @param arg1
	 *            保留参数
	 * @param arg2
	 *            保留参数
	 */
	void onConnectSuccess(THttpRequest request, Object arg1, Object arg2);

	// 数据读取不是在内部做的,所以无法给出
	// /**
	// * 正在传输数据
	// * @param arg1
	// * @param arg2
	// * @param arg2
	// */
	// void onProgress(Object arg1, Object arg2, Object arg3);

	/**
	 * 数据传输完成
	 * 
	 * @param request
	 * @param arg1
	 *            保留参数
	 * @param arg2
	 *            保留参数
	 */
	void onTransFinish(THttpRequest request, Object arg1, Object arg2);

	/**
	 * 异常反馈
	 * 
	 * @param e
	 * @param arg1
	 *            保留参数
	 * @param arg2
	 *            保留参数
	 */
	void onException(Exception e, Object arg1, Object arg2);
}
