package com.gau.utils.net.asrFiltier;

import org.apache.http.HttpMessage;

/**
 * 用于过滤运营商的数据。 在此只能通过头信息来进行过滤，如果涉及需要通过数据解析来进行过滤，请在IHttpOPerator中实现
 * 
 * @author guoshengliang
 * @version 1.0
 */
public interface IAsrFilter {

	/**
	 * 过滤当前http反馈信息是否是运营商数据
	 * 
	 * @param httpMsg
	 *            http反饋的鏈接數據Bean
	 * @return 如果当前数据是运营商的反馈true，负责反馈false
	 */
	public abstract boolean isAsrResponse(HttpMessage httpMsg);
}
