package com.gau.utils.net.operator;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;

import com.gau.utils.net.request.THttpRequest;
import com.gau.utils.net.response.BasicResponse;
import com.gau.utils.net.response.IResponse;

/**
 * 字节数组式处理
 * 
 * @author guoshengliang
 * @version 1.0
 */
public class ByteArrayHttpOperatror implements IHttpOperator {

	@Override
	public IResponse operateHttpResponse(THttpRequest request,
			HttpResponse response) throws IOException {
		// TODO 根据链接类型进行byte size的配置，加强下载速度
		HttpEntity entity = response.getEntity();

		InputStream is = entity.getContent();

		DataInputStream dis = new DataInputStream(is);
		byte[] datas = null;
		if (entity.isChunked()) {
			// chuncked编码，不能直接获取内容长度
			StringBuffer stringBuffer = new StringBuffer();
			byte[] byteData = new byte[1024];
			int n;
			while ((n = dis.read(byteData)) != -1) {
				stringBuffer.append(new String(byteData, 0, n));
			}
			datas = stringBuffer.toString().getBytes();
		} else {
			long dataLength = ( long ) entity.getContentLength();
			// TODO异常处理
			if (dataLength <= 0) {
				return null;
			}
			datas = new byte[( int ) dataLength];
			dis.readFully(datas);
		}
		BasicResponse reslut = new BasicResponse(
				IResponse.RESPONSE_TYPE_BYTEARRAY, datas);

		return reslut;
	}

	// private int caculate

}
