package com.gau.utils.net.operator;

import java.io.IOException;

import org.apache.http.HttpResponse;

import com.gau.utils.net.request.THttpRequest;
import com.gau.utils.net.response.IResponse;

/**
 * 处理网络反馈的HttpRespose，并将处理过的数据交给数据
 * 
 * @author guoshengliang
 * @version 1.0
 */
public interface IHttpOperator {

	/**
	 * 处理网络正常返回的Response（responseCode=200)，建议以Decorator模式實現
	 * 
	 * @param request
	 *            请求的request
	 * @param response
	 *            正常反馈的Response
	 * @return 處理后的數據句柄
	 * @throws IllegalStateException
	 *             如果在网络处理中异常抛出
	 * @throws IOException
	 *             如果在网络处理中异常抛出
	 */
	public abstract IResponse operateHttpResponse(THttpRequest request,
			HttpResponse response) throws IllegalStateException, IOException;
}
