package com.gau.utils.net.response;

/**
 * 数据对象操作句柄
 * 
 * @author guoshengliang
 * @version 1.0
 */
public interface IResponse {
	/**
	 * 返回类型：异常
	 */
	public static final int RESPONSE_TYPE_EXCEPTION = -1;

	/**
	 * 返回类型：字节数组
	 */
	public static final int RESPONSE_TYPE_BYTEARRAY = 1;

	/**
	 * 返回类型：字节流
	 */
	public static final int RESPONSE_TYPE_STREAM = 2;

	/**
	 * 返回类型：字符串
	 */
	public static final int RESPONSE_TYPE_STRING = 3;

	/**
	 * 返回类型：JSONObject
	 */
	public static final int RESPONSE_TYPE_JSONOBJECT = 4;

	/**
	 * 返回类型：JSONArray
	 */
	public static final int RESPONSE_TYPE_JSONARRAY = 5;

	/**
	 * 获取数据对象的类型
	 * 
	 * @return 数据对象类型
	 */
	public abstract int getResponseType();

	/**
	 * 获取数据对象，根據數據對象的類型做真實數據對象轉換
	 * 
	 * @return 反馈数据对象 ，如果沒有獲取到數據反饋null
	 */
	public abstract Object getResponse();
}
