package com.gau.utils.net.util;

import android.util.Log;

/**
 * 网络操作过程中日志辅助类
 * @author guoshengliang
 * @version 1.0
 */
public class NetLog {

	public static final String LOG_LABEL = "netLog";

	private static boolean isPrintLog = false;

	public static boolean isPrintLog() {
		return isPrintLog;
	}

	public static void printLog(boolean printlog) {
		isPrintLog = printlog;
	}

	public static void info(String info, Throwable tr) {
		if (isPrintLog) {
			Log.i(LOG_LABEL, info, tr);
		}
	}

	public static void erro(String info, Throwable tr) {
		if (isPrintLog) {
			Log.e(LOG_LABEL, info, tr);
		}
	}

	public static void debug(String info, Throwable tr) {
		if (isPrintLog) {
			Log.d(LOG_LABEL, info, tr);
		}
	}
}
