package com.go.launcher.taskmanager;

import java.util.ArrayList;

import android.content.Context;

public interface ITaskManager {
	/**
	 * 获取当前运行的程序列表
	 * @return 程序列表
	 */
    public ArrayList<_APPINFOR> retriveAppList(Context context);

    /**
     * 终止程序
     * @param pid
     */
    public void terminateAppByPid(int pid);

    /**
     * 终止所有正在运行的程序
     */
    public void terminateAll();

    /**
     * 清理任务管理器，回收资源
     */
    public void clearTaskManager();

    /**
     * 获取手机总内存
     * @return 手机总内存(KB)
     */
    public long retriveTotalMemory();

    /**
     * 获取手机可用内存
     * @return 可用内存(KB)
     */
    public long retriveAvailableMemory();
}
