package com.go.util.lib;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import android.appwidget.AppWidgetManager;
import android.content.ComponentName;
import android.os.Build.VERSION;

/**
 * 
 * <br>类描述:兼容SDK16以上的bindAppWidgetId
 * <br>功能详细描述:
 * 
 * @author  骆培焕
 * @date  [2012-11-30]
 */
public final class AppWidgetManagerWrapper {
	private static Method sBindAppWidget_16 = null;
	private static Method sBindAppWidget_15 = null;

	public static void bindAppWidgetId(AppWidgetManager manager, int appWidgetId,
			ComponentName provider) {
		if (VERSION.SDK_INT >= 16) { // CHECKSTYLE IGNORE
			if (sBindAppWidget_16 == null) {
				try {
					sBindAppWidget_16 = AppWidgetManager.class.getDeclaredMethod(
							"bindAppWidgetIdIfAllowed", int.class, ComponentName.class);
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}
			}
			try {
				sBindAppWidget_16.invoke(manager, appWidgetId, provider);
			} catch (IllegalArgumentException e) {
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				e.printStackTrace();
			}
		} else {
			if (sBindAppWidget_15 == null) {
				try {
					sBindAppWidget_15 = AppWidgetManager.class.getDeclaredMethod(
							"bindAppWidgetId", int.class, ComponentName.class);
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}
			}
			try {
				sBindAppWidget_15.invoke(manager, appWidgetId, provider);
			} catch (IllegalArgumentException e) {
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				e.printStackTrace();
			}
//			manager.bindAppWidgetId(appWidgetId, provider);
		}
	}
}
