package com.jb.ga0.commerce.util;

/**
 * 
 * <br>类描述:点击事件的统一时间控制
 * <br>功能详细描述:
 * 
 * @author  zhengxiangcan
 * @date  [2013-4-27]
 */
public class ClickManager {
	
	private long mLastClickTime;
	private static ClickManager sManager;
	private static final long CLICK_INTERVAL = 500;
	public static final long CLICK_INTERVAL_LONG = 1000;
	
	private ClickManager() {
	}
	
	public static synchronized ClickManager getManager() {
		if (sManager == null) {
			sManager = new ClickManager();
		}
		return sManager;
	}
	
	public boolean isCanClick() {
		long nowTime = System.currentTimeMillis();
		if (nowTime - mLastClickTime >= CLICK_INTERVAL) {
			mLastClickTime = nowTime;
			return true;
		}
		mLastClickTime = nowTime;
		return false;
	}
	
	public boolean isCanClick(long clickInterval) {
		long nowTime = System.currentTimeMillis();
		if (nowTime - mLastClickTime >= clickInterval) {
			mLastClickTime = nowTime;
			return true;
		}
		mLastClickTime = nowTime;
		return false;
	} 

}
