package com.jb.ga0.commerce.util;

import android.app.ActivityManager;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/**
 * Created by xiexingwu on 2016/7/15.
 */
public class MemoryTool {

    public static long getAvaliableMemory(ActivityManager mActMgr) {
        ActivityManager.MemoryInfo memInfo = new ActivityManager.MemoryInfo();
        mActMgr.getMemoryInfo(memInfo);
        return memInfo.availMem >> 10; // div 1024
    }

    /**
     * 获取手机总内存
     *
     * @return 手机总内存(KB)
     */
    public static long getTotalMemory() {
        long totalMemroy = 0;
        BufferedReader bufReader = null;
        FileReader fileReader = null;
        try {
            fileReader = new FileReader("/proc/meminfo");
            bufReader = new BufferedReader(fileReader, 4096);
            String cat = bufReader.readLine(); // 读取第一行“MemTotal: 415268 kB”
            if (cat != null) {
                String[] array = cat.split("\\s+");
                if (array != null && array.length > 1) {
                    // 数组第2个为内存大小
                    totalMemroy = Long.parseLong(array[1]);
                }
                array = null;
            }
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (bufReader != null) {
                try {
                    bufReader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (fileReader != null) {
                try {
                    fileReader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return totalMemroy;
    }
}
