package com.jb.ga0.commerce.util.encrypt;

import android.util.Base64;

import com.jb.ga0.commerce.util.LogUtils;

import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;

public class DesUtil {

    public static final String TAG = "DesUtil";

    public static String encryptDesSafe(String key, String data) {
        String result = null;
        try {
            result = encryptDes(key, data);
        } catch (Throwable e) {
            LogUtils.d(TAG, "encryptDesSafe-> ", e);
        }
        return result;
    }

    /**
     * 加密
     *
     * @param data
     * @return
     * @throws NoSuchAlgorithmException
     * @throws InvalidKeyException
     * @throws InvalidKeySpecException
     * @throws NoSuchPaddingException
     * @throws IllegalBlockSizeException
     * @throws BadPaddingException
     * @throws UnsupportedEncodingException
     */
    public static String encryptDes(String key, String data)
            throws NoSuchAlgorithmException, InvalidKeyException, InvalidKeySpecException, NoSuchPaddingException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {

        DESKeySpec desKey = new DESKeySpec(key.getBytes());
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
        SecretKey securekey = keyFactory.generateSecret(desKey);

        Cipher cipher = Cipher.getInstance("DES");
        cipher.init(Cipher.ENCRYPT_MODE, securekey);
        return Base64.encodeToString(cipher.doFinal(data.getBytes("utf-8")), Base64.NO_WRAP);
    }

    public static String decryptDesSafe(String key, String src) {
        String result = null;
        try {
            result = decryptDes(key, src);
        } catch (Throwable e) {
            LogUtils.d(TAG, "decryptDesSafe-> ", e);
        }
        return result;
    }


    /**
     * 解密
     *
     * @param src
     * @return
     * @throws InvalidKeyException
     * @throws NoSuchAlgorithmException
     * @throws InvalidKeySpecException
     * @throws NoSuchPaddingException
     * @throws UnsupportedEncodingException
     * @throws IllegalBlockSizeException
     * @throws BadPaddingException
     */
    public static String decryptDes(String key, String src)
            throws InvalidKeyException, NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, UnsupportedEncodingException, IllegalBlockSizeException, BadPaddingException {

        DESKeySpec desKey = new DESKeySpec(key.getBytes());
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
        SecretKey securekey = keyFactory.generateSecret(desKey);

        Cipher cipher = Cipher.getInstance("DES");
        cipher.init(Cipher.DECRYPT_MODE, securekey);
        return new String(cipher.doFinal(Base64.decode(src, Base64.NO_WRAP)), "utf-8");
    }

}