package com.jb.ga0.commerce.util.io;

import java.io.InputStream;

import org.apache.http.util.ByteArrayBuffer;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

/**
 * 位图解码器, 主要用于内存控制
 * @author matt
 *
 */
public class BitmapDecoder {
	public static Bitmap decodeFile(String filtPath, int restrictWidth, int restrictHeight) {
		//TODO DEBUG BY MATT
		return null;
	}

	public static Bitmap decodeFileByWidth(String filePath, int restrictWidth) {
		BitmapFactory.Options options = new BitmapFactory.Options();
		options.inJustDecodeBounds = true;
		BitmapFactory.decodeFile(filePath, options);
		if (options.outWidth <= 0 || options.outHeight <= 0) {
			return null;
		}
		
		options.inJustDecodeBounds = false;
        //缩放比
        int be = (int) (options.outWidth / restrictWidth);
        if (be <= 0) {
        	be = 1;
        }
        options.inSampleSize = be;
		
		return BitmapFactory.decodeFile(filePath, options);
	}
	
	public static Bitmap decodeFileByHeight(String filePath, int restrictHeight) {
		BitmapFactory.Options options = new BitmapFactory.Options();
		options.inJustDecodeBounds = true;
		BitmapFactory.decodeFile(filePath, options);
		if (options.outWidth <= 0 || options.outHeight <= 0) {
			return null;
		}
		
		options.inJustDecodeBounds = false;
        //缩放比
        int be = (int) (options.outHeight / restrictHeight);
        if (be <= 0) {
        	be = 1;
        }
        options.inSampleSize = be;
		
		return BitmapFactory.decodeFile(filePath, options);
	}
	
	public static Bitmap decodeStream(InputStream is, int restrictWidth, int restrictHeight) {
		try {
			byte[] data = toByteArray(is);
			return decodeByteArray(data, 0, data.length, restrictWidth, restrictHeight);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static Bitmap decodeStreamByWidth(InputStream is, int restrictWidth) {
		try {
			byte[] data = toByteArray(is);
			return decodeByteArrayByWidth(data, 0, data.length, restrictWidth);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
		
//		BitmapFactory.Options options = new BitmapFactory.Options();
//		options.inJustDecodeBounds = true;
//		BitmapFactory.decodeStream(is, null, options);
//		if (options.outWidth <= 0 || options.outHeight <= 0) {
//			return null;
//		}
//		
//		options.inJustDecodeBounds = false;
//        //缩放比
//        int be = (int)(options.outWidth / restrictWidth);
//        if (be <= 0) {
//        	be = 1;
//        }
//        options.inSampleSize = be;
//		
//		return BitmapFactory.decodeStream(is, null, options);
	}
	
	public static Bitmap decodeStreamByHeight(InputStream is, int restrictHeight) {
		try {
			byte[] data = toByteArray(is);
			return decodeByteArrayByHeight(data, 0, data.length, restrictHeight);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
		
//		BitmapFactory.Options options = new BitmapFactory.Options();
//		options.inJustDecodeBounds = true;
//		BitmapFactory.decodeStream(is, null, options);
//		if (options.outWidth <= 0 || options.outHeight <= 0) {
//			return null;
//		}
//		
//		options.inJustDecodeBounds = false;
//        //缩放比
//        int be = (int)(options.outHeight / restrictHeight);
//        if (be <= 0) {
//        	be = 1;
//        }
//        options.inSampleSize = be;
//		
//		return BitmapFactory.decodeStream(is, null, options);
	}
	
	public static Bitmap decodeByteArray(byte[] data, int offset, int length, int restrictWidth, int restrictHeight) {
		//TODO DEBUG BY MATT
		return null;
	}
	
	public static Bitmap decodeByteArrayByWidth(byte[] data, int offset, int length, int restrictWidth) {
		BitmapFactory.Options options = new BitmapFactory.Options();
		options.inJustDecodeBounds = true;
		BitmapFactory.decodeByteArray(data, offset, length, options);
		if (options.outWidth <= 0 || options.outHeight <= 0) {
			return null;
		}
		
		options.inJustDecodeBounds = false;
        //缩放比
        int be = (int) (options.outWidth / restrictWidth);
        if (be <= 0) {
        	be = 1;
        }
        options.inSampleSize = be;
		
		return BitmapFactory.decodeByteArray(data, offset, length, options);
	}
	
	public static Bitmap decodeByteArrayByHeight(byte[] data, int offset, int length, int restrictHeight) {
		BitmapFactory.Options options = new BitmapFactory.Options();
		options.inJustDecodeBounds = true;
		BitmapFactory.decodeByteArray(data, offset, length, options);
		if (options.outWidth <= 0 || options.outHeight <= 0) {
			return null;
		}
		
		options.inJustDecodeBounds = false;
        //缩放比
        int be = (int) (options.outHeight / restrictHeight);
        if (be <= 0) {
        	be = 1;
        }
        options.inSampleSize = be;
		
		return BitmapFactory.decodeByteArray(data, offset, length, options);
	}
	
	private static byte[] toByteArray(InputStream instream) throws Exception {
        if (instream == null) {
            return new byte[] {};
        }
        int totalSize = (int) instream.available();
        
        if (totalSize < 0) {
            totalSize = 4096;
        }
        
        ByteArrayBuffer buffer = new ByteArrayBuffer(totalSize);
        try {
            byte[] tmp = new byte[4096];
            int l;
            while ((l = instream.read(tmp)) != -1) {
                buffer.append(tmp, 0, l);
            }
        } catch (Exception e) {
        	e.printStackTrace();
		} finally {
            instream.close();
        }
        return buffer.toByteArray();
    }
}
