package com.jb.ga0.commerce.util.retrofit.Interceptor;

import com.jb.ga0.commerce.util.LogUtils;

import java.io.IOException;

import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

import static com.jb.ga0.commerce.util.retrofit.HttpConstants.LogTag.TAG;

/**
 * 响应数据解压拦截器
 * Created by matt on 2017/10/21.
 */
public class GunzipResponseInterceptor implements Interceptor {
    @Override
    public Response intercept(Chain chain) throws IOException {
        LogUtils.i(TAG, "GunzipResponseInterceptor#intercept() enter");

        Request request = chain.request();
        //使用透明压缩，可以让okhttp自动解压数据
        request = request.newBuilder().removeHeader("Accept-Encoding").build();

        Response response = chain.proceed(request);
        return response;
    }
}
