package com.jb.ga0.commerce.util.retrofit.Interceptor;

import java.io.IOException;

import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

import static com.jb.ga0.commerce.util.retrofit.Interceptor.RepeatRequestCtrl.REPEAT_REQUEST_KEY;

/**
 * 定时请求拦截器，主要是在成功时记录时间点
 * Created by matt on 2017/10/31.
 */
public class RepeatRequestInterceptor implements Interceptor {


    @Override
    public Response intercept(Interceptor.Chain chain) throws IOException {
        Request request = chain.request();
        String requestKey = request.header(REPEAT_REQUEST_KEY);
        request = request.newBuilder().removeHeader(REPEAT_REQUEST_KEY).build();

        Response response = chain.proceed(request);
        //服务器有响应，就当作请求成功了
        if (response != null) {
            RepeatRequestCtrl.getInstance().recordSuccess(requestKey);
        }

        return response;
    }
}
