package com.jb.ga0.commerce.util.retrofit.Interceptor;

import android.content.Context;

import com.jb.ga0.commerce.util.retrofit.HttpConstants;
import com.jb.ga0.commerce.util.LogUtils;

import java.io.IOException;

import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

import static com.jb.ga0.commerce.util.retrofit.Interceptor.RetryAfterNetOkCtrl.RETRY_AFTER_NET_OK_KEY;

/**
 * 网络失败时，取缓存数据
 * Created by matt on 2017/10/19.
 */
public class RetryAfterNetOkInterceptor implements Interceptor {
    private static final String TAG = HttpConstants.LogTag.TAG;

    private Context mContext;

    public RetryAfterNetOkInterceptor(Context context) {
        mContext = context.getApplicationContext();
    }

    @Override
    public Response intercept(Chain chain) throws IOException {
        LogUtils.i(TAG, "RetryAfterNetOkInterceptor#intercept() enter");

        Request request = chain.request();
        String requestKey = request.header(RETRY_AFTER_NET_OK_KEY);
        request = request.newBuilder().removeHeader(RETRY_AFTER_NET_OK_KEY).build();

        Response response = null;
        try {
            response = chain.proceed(request);
        } finally {
            //拿不到服务器响应，即是网络失败
            RetryAfterNetOkCtrl.getInstance(mContext).recordResult(requestKey, response != null);
        }
        return response;
    }
}
