package com.jb.ga0.commerce.util.retrofit.Interceptor;

import com.jb.ga0.commerce.util.LogUtils;

import java.io.IOException;

import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

import static com.jb.ga0.commerce.util.retrofit.HttpConstants.LogTag.TAG;

/**
 * 简单重试拦截器，在失败后立即重试
 * Created by matt on 2017/10/18.
 */
public class SimpleRetryIntercepter implements Interceptor {

    //最大重试次数
    public int mMaxReatryCount;

    public SimpleRetryIntercepter(int maxReatryCount) {
        mMaxReatryCount = maxReatryCount;
    }

    @Override
    public Response intercept(Chain chain) throws IOException {
        LogUtils.i(TAG, "RetryAfterNetOkInterceptor#intercept() enter");

        Request request = chain.request();
        Response response = chain.proceed(request);
        int retryCount = 0;
        while (!response.isSuccessful() && retryCount < mMaxReatryCount) {
            retryCount++;
            response = chain.proceed(request);
        }
        return response;
    }
}