package com.jb.ga0.commerce.util.retrofit.test;

import java.util.List;

import retrofit2.Call;
import retrofit2.http.GET;
import retrofit2.http.Headers;
import retrofit2.http.Url;

/**
 * Created by matt on 2017/10/23.
 */
public interface TestService {
    @GET
    Call<AbResponse> getAbTest(@Url String url);

    @GET
    Call<HttpResult<List<ASubject>>> getMovie(@Url String url);

    /**
     *
     * @param url
     * @return
     */
    @Headers("retry_after_net_ok_key: https://api.douban.com/v2/movie/retry")
    @GET
    Call<HttpResult<List<ASubject>>> getMovieRetry(@Url String url);

    /**
     *
     * @param url
     * @return
     */
    @Headers("repeat_request_key: https://api.douban.com/v2/movie/repeat")
    @GET
    Call<HttpResult<List<ASubject>>> getMovieRepeat(@Url String url);

    static class AbResponse {
        public boolean success;
        public AbDatas datas;
    }

    static class AbDatas {
        public AbInfos infos;
    }

    static class AbInfos {
        public List<AbCfg> cfgs;
    }

    static class AbCfg {
        public int cfg_tb_id;
        public int cfg_id;
        public int plug_ins_update;

        @Override
        public String toString() {
            return String.format("{cfg_tb_id=%d, cfg_id=%d, plug_ins_update=%d}", cfg_tb_id, cfg_id, plug_ins_update);
        }
    }


}
