package com.jiubang.commerce.buychannel.buyChannel.Statistics;

import android.content.Context;
import android.content.SharedPreferences;

import com.jb.ga0.commerce.util.statistics.BaseStatistic;
import com.jiubang.commerce.buychannel.BuyChannelApi;
import com.jiubang.commerce.buychannel.BuyChannelDataMgr;
import com.jiubang.commerce.buychannel.BuySdkConstants;
import com.jiubang.commerce.buychannel.buyChannel.bean.BuyChannelBean;
import com.jiubang.commerce.buychannel.buyChannel.utils.TextUtils;

/**
 * Created by mayunlong on 16-12-19.
 */

public class StatisticsDebug extends BaseStatistic {

    /**
     * 统计日志序列号
     */
    private static final int LOG_ID = 103;
    private static String sReferrer;
    private static String sConversionData;

    public static void upload(Context context, Statistic103Params params) {
        SharedPreferences sp = BuyChannelDataMgr.getInstance(context).getSharedPreferences(context);
        BuyChannelBean buyChannelBean = BuyChannelApi.getBuyChannelBean(context);
        String cid = sp.getString(BuySdkConstants.CID_45, null);

        StringBuffer buffer = new StringBuffer();

        //功能点ID
        appendStatisticField(buffer, "670");
        buffer.append(SEPARATOR);

        //统计对象
        appendStatisticField(buffer, buyChannelBean.getBuyChannel());
        buffer.append(SEPARATOR);

        //操作代码
        appendStatisticField(buffer, params.mCode);
        buffer.append(SEPARATOR);

        //操作结果
        appendStatisticField(buffer, "1");
        buffer.append(SEPARATOR);
        if (params.mReferrer != null) {
            sReferrer = params.mReferrer;
        } else {
            sReferrer = sp.getString(BuySdkConstants.REFERRER, null);
        }
        // 入口，Referrer
        appendStatisticField(buffer, sReferrer);
        buffer.append(SEPARATOR);

        // tab分类，af原始数据
        if (!TextUtils.isEmpty(params.mAppflyer)) {
            sConversionData = params.mAppflyer;
        } else {
            sConversionData = sp.getString(BuySdkConstants.CONVERSIONDATA, null);
        }
        appendStatisticField(buffer, sConversionData);
        buffer.append(SEPARATOR);

        //位置
        appendStatisticField(buffer, String.valueOf(params.mPosition));
        buffer.append(SEPARATOR);

        //产品cid
        appendStatisticField(buffer, cid);


        uploadStatisticData(context, 103, 670, buffer, new SatisticsUploadPolicy[0]);

       /* LogUtils.v(BuySdkConstants.LOG_TAG, "/统计对象 : " + "670"
                + "   /操作代码 : " + params.mCode
                + "   /操作结果 : " + "1"
                + "   /Referrer : " + params.mReferrer
                + "   /位置 : " + params.mPosition);*/
//        LogUtils.v(BuySdkConstants.LOG_TAG, buffer.toString());
    }


    public static class Statistic103Params {


        /**
         * 渠道
         */
        protected String mChannel;

        /**
         * 广告ID
         */
        protected String mAdvertId;

        /**
         * 买量渠道名称
         */
        protected String mBuyChannel;

        /**
         * 操作码
         */
        protected String mCode;

        /**
         * Referrer
         */
        protected String mReferrer;
        /**
         * 位置
         */
        protected int mPosition;

        /**
         * af原始数据
         */
        protected String mAppflyer;

        /**
         * 渠道
         *
         * @param channel {@link Statistics45.Statistic45Params#mChannel}
         * @return
         */
        public Statistic103Params channel(String channel) {
            mChannel = channel;
            return this;
        }

        /**
         * 广告ID
         *
         * @param advertId {@link Statistics45.Statistic45Params#mAdvertId}
         * @return
         */
        public Statistic103Params advertId(String advertId) {
            mAdvertId = advertId;
            return this;
        }

        /**
         * 买量渠道名称
         */
        public Statistic103Params buychannel(String buychannel) {
            mBuyChannel = buychannel;
            return this;
        }


        /**
         * 操作码
         */
        public Statistic103Params code(String code) {
            mCode = code;
            return this;
        }

        /**
         * Referrer
         *
         * @param referrer {@link Statistics45.Statistic45Params#mReferrer}
         * @return
         */
        public Statistic103Params referrer(String referrer) {
            mReferrer = referrer;
            return this;
        }

        /**
         * 位置position
         */
        public Statistic103Params position(int position) {
            mPosition = position;
            return this;
        }

        /**
         * 位置position
         */
        public Statistic103Params appflyer(String conversationData) {
            mAppflyer = conversationData;
            return this;
        }


    }


}
