package com.jiubang.commerce.buychannel.buyChannel.Statistics;

import android.content.Context;

import com.jb.ga0.commerce.util.LogUtils;
import com.jb.ga0.commerce.util.statistics.BaseStatistic;
import com.jiubang.commerce.buychannel.BuySdkConstants;
import com.jiubang.commerce.buychannel.buyChannel.manager.GpVersionHelper;
import com.jiubang.commerce.buychannel.buyChannel.utils.AppInfoUtils;
import com.jiubang.commerce.buychannel.buyChannel.utils.BuyChannelUtils;
import com.jiubang.commerce.buychannel.buyChannel.utils.TextUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

/**
 * 用户统计
 * Created by chenchongji on 2016/6/14.
 */
public class UserStatistics extends BaseStatistic {


    /**
     * 上传19协议用户统计
     *
     * @param context
     * @param channel
     * @param isPay
     * @param needRootInfo
     * @param key
     * @param isNew
     */

   /* public static void upload19(Context context, String channel, boolean isPay,
                                boolean needRootInfo, String key, boolean isNew) {
        final SharedPreferences mSp = BuyChannelDataMgr.getInstance(context).getSharedPreferences(context);

        if (!mSp.getBoolean(BuySdkConstants.ALREADY_UPLOAD_19, false)) {
            StatisticsManager.getInstance(context).upLoadBasicInfoStaticData(channel, isPay, needRootInfo, key, isNew);
            LogUtils.v(BuySdkConstants.LOG_TAG, "19协议/买量渠道号 : " + channel
                    + "   /是否付费用户 : " + isPay
                    + "   /是否需要上传root信息 : " + needRootInfo
                    + "   /19协议里的正版标识 : " + key
                    + "   /是否新用户 : " + isNew

            );
            mSp.edit().putBoolean(BuySdkConstants.ALREADY_UPLOAD_19, true).commit();
        } else {
            Log.i(BuySdkConstants.LOG_TAG, "[BuyChannelSetting::upload19]已经上传了一次19协议");
        }

    }*/

    /**
     * 上传买量统计
     */

    public static void upload45(Context context, boolean isGoKeyboard, int funId, String sender, String afDetail, String referrer, String userType, String tag, String afAgency, boolean isAfter19) {

        Statistics45.Statistic45Params params = new Statistics45.Statistic45Params();
        /*Statistics45.Statistic45Params oldParams = BuyChannelUtils.getOldParams(context);*/
        String oldSender = BuyChannelUtils.getOldSender(context);
        String oldUserType = BuyChannelUtils.getOldUserType(context);

        if (oldSender != null && sender != null && sender.equals(oldSender) && oldUserType != null && userType != null && userType.equals(oldUserType)) {
            //如果sender数据或者用户类型和上一次45上传的相同，都不在上传45协议
            LogUtils.i(BuySdkConstants.LOG_TAG, "[UserStatistics::upload45] sender数据或者用户类型和上一次45上传的相同，" +
                    "不在上传45协议,oldParams:sender=" + oldSender + ",oldParams:userType=" + oldUserType);
            //TODO 操作码2,位置10,两次45协议内容相同，不上传45协议
            StatisticsDebug.Statistic103Params statistic103ParamsP10 = new StatisticsDebug.Statistic103Params();
            statistic103ParamsP10.code(BuySdkConstants.DEBUG_CODE2).referrer(referrer).position(4);
            StatisticsDebug.upload(context, statistic103ParamsP10);
            return;
        }
        //获取google-play版本名
        String gpVersionName = GpVersionHelper.getInstance(context).getGpVersionName();
        //买量sdk版本
        String versionCode = BuySdkConstants.SDK_VERSION_NAME;
        params.sender(sender).referrer(referrer).afDetail(afDetail).associatedObj(context.getPackageName()).funId(funId).
                operationCode("k001").gpVersionName(gpVersionName).userType(userType).tag(tag)
                .sdkVersionCode(versionCode).afAgency(afAgency).advertId(AppInfoUtils.getAdvertisingId(context));
        Statistics45.upload(context, isGoKeyboard, params, isAfter19);

        BuyChannelUtils.setOldSender(context, params.getSender());
        BuyChannelUtils.setOldUserType(context, params.getUserType());

    }



    /**
     * 获取FB带量安装的45协议关联对象
     *
     * @param campaign
     * @param adset
     * @param adgroup
     * @return
     */
    public static String get45AssociatedObjFB(String campaign, String adset, String adgroup) {
        // utm_source=fb&utm_medium=banner&utm_campaign=${campaign}&gokey_channel=${adset}&gokey_click_id=${adgroup}
        StringBuilder sb = new StringBuilder("utm_source=fb&utm_medium=banner");
        sb.append("&utm_campaign=");
        sb.append(campaign);
        sb.append("&gokey_channel=");
        sb.append(adset);
        sb.append("&gokey_click_id=");
        sb.append(adgroup);
        return sb.toString();
    }

    /**
     * 获取其他来源带量安装的45协议关联对象
     *
     * @param mediaSource
     * @param campaign
     * @param adset
     * @param adgroup
     * @return
     */
    public static String get45AssociatedObjOther(String mediaSource, String campaign, String adset, String adgroup) {
        // utm_source=${mediaSource}&utm_medium=banner&utm_campaign=${campaign}&gokey_channel=${adset}&gokey_click_id=${adgroup}
        StringBuilder sb = new StringBuilder("utm_source=");
        sb.append(mediaSource);
        sb.append("&utm_medium=banner");
        sb.append("&utm_campaign=");
        sb.append(campaign);
        sb.append("&gokey_channel=");
        sb.append(adset);
        sb.append("&gokey_click_id=");
        sb.append(adgroup);
        return sb.toString();
    }

    public static String get45AssociatedEmptyOther(String mediaSource) {
        // utm_source=${mediaSource}&utm_medium=banner&utm_campaign=${campaign}&gokey_channel=${adset}&gokey_click_id=${adgroup}
        StringBuilder sb = new StringBuilder("utm_source=");
        sb.append(mediaSource);
        return sb.toString();
    }

    /**
     * 获取adwords带量安装的45协议关联对象,需对adwords_gdn进行特殊处理
     *
     * @param campaign
     * @return
     */
    public static String get45AssociatedObjAdwords(String campaign, boolean isGdnCampaignids) {
        // utm_source=adwords&utm_medium=banner&utm_campaign=adwords&gokey_channel=&gokey_click_id=
        final StringBuilder sb = new StringBuilder(
                "utm_source=");
        String channel;
        if (isGdnCampaignids) {
            channel = "adwords_gdn";
        } else {
            channel = "adwords";
        }
        sb.append(channel);
        sb.append("&utm_medium=banner");
        sb.append("&utm_campaign=");
        sb.append(campaign);
        sb.append("&gokey_channel=&gokey_click_id=");

        return sb.toString();
    }

    /**
     * 获取twitter带量安装的45协议关联对象
     *
     * @param campaign
     * @return
     */
    public static String get45AssociatedObjTwitter(String campaign) {
        // utm_source=twitter&utm_medium=banner&utm_campaign=twitter&gokey_channel=&gokey_click_id=
        StringBuilder sb = new StringBuilder(
                "utm_source=twitter&utm_medium=banner");
        sb.append("&utm_campaign=");
        sb.append(campaign);
        sb.append("&gokey_channel=&gokey_click_id=");
        return sb.toString();
    }

    public static void logInstallReferrer(String referrer) {
        uploadLog("referrer", referrer);
    }

    /**
     * 上传Appsflyer分析日志
     *
     * @param installReferrer       原始信息
     * @param conversionDataJsonStr Appsfyler信息
     * @param analysistResult       分析结果
     * @param afStatus
     */
    public static void logAppsflyerInfo(String installReferrer, String conversionDataJsonStr, String analysistResult, String afStatus) {
        String tag;
        if ("Organic".equalsIgnoreCase(afStatus)) {
            tag = "report_appsflyer_organic";
        } else {
            tag = "report_appsflyer_not_organic";
        }
        final Map<String, String> extraInfos = new HashMap<String, String>();
        extraInfos.put("install_referrer", installReferrer == null ? "" : installReferrer);
        if (!TextUtils.isEmpty(conversionDataJsonStr)) {
            extraInfos.put("appsflyer_conversionData", conversionDataJsonStr);
        }
        if (!TextUtils.isEmpty(analysistResult)) {
            extraInfos.put("analysist_result", analysistResult);
        }
        uploadLog(tag, extraInfos);
    }

    /**
     * 获取Appsflyer分析结果
     *
     * @param isFb
     * @param campaign
     * @param adSet
     * @param adGroup
     * @param mediaSource
     * @param agency
     * @param afStatus
     * @param buyChannel
     */
    public static String getAppsflyerAnalysistResult(boolean isFb,
                                                     String campaign, String adSet, String adGroup, String mediaSource,
                                                     String agency, String afStatus, String buyChannel) {
        String info = null;
        final JSONObject infoJson = new JSONObject();
        try {
            infoJson.put("is_fb", String.valueOf(isFb));
            if (!TextUtils.isEmpty(campaign)) {
                infoJson.put("campaign", campaign);
            }
            if (!TextUtils.isEmpty(adSet)) {
                infoJson.put("adset", adSet);
            }
            if (!TextUtils.isEmpty(adGroup)) {
                infoJson.put("adgroup", adGroup);
            }
            if (!TextUtils.isEmpty(mediaSource)) {
                infoJson.put("media_source", mediaSource);
            }
            if (!TextUtils.isEmpty(agency)) {
                infoJson.put("agency", agency);
            }
            if (!TextUtils.isEmpty(agency)) {
                infoJson.put("agency", agency);
            }
            if (!TextUtils.isEmpty(afStatus)) {
                infoJson.put("af_status", afStatus);
            }
            if (!TextUtils.isEmpty(buyChannel)) {
                infoJson.put("buyChannel", buyChannel);
            }
            // 需要上传的数据
            info = infoJson.toString();
        } catch (JSONException e) {
            e.printStackTrace();
        } catch (Throwable e) {
            e.printStackTrace();
        }

        return infoJson.toString();
    }

    private static void uploadLog(String tag, String content) {
        LogUtils.i(BuySdkConstants.LOG_TAG, "[UserStatistics::uploadLog] tag:" + tag + ", content:" + content);
        //TODO DEBUG
        //通过统计协议上传，需要替换字符|
        // content = content.replaceAll("\\u007C", "#");

    }

    private static void uploadLog(String tag, Map<String, String> contents) {
        String content = "";
        final JSONObject jsonObj = new JSONObject();
        try {
            final Set<String> keys = contents.keySet();
            for (String key : keys) {
                if (TextUtils.isEmpty(key)) {
                    continue;
                }
                String value = contents.get(key);
                jsonObj.put(key, value);
            }
            content = jsonObj.toString();
        } catch (JSONException e) {
            e.printStackTrace();
        } catch (Throwable e) {
            e.printStackTrace();
        }

        uploadLog(tag, content);
    }
}
