package com.jiubang.commerce.buychannel.buyChannel.bean;

import android.text.TextUtils;

import org.json.JSONException;
import org.json.JSONObject;

/**
 * Created by Administrator on 2016/9/24.
 */

public class BuyChannelBean {
    /**
     * 买量渠道
     * created by mayunlong.
     * created date 16-11-4.
     */
    private String mBuyChannel = "unknown_buychannel";
    /**
     * 渠道判断的来源
     * created by mayunlong.
     * created date 16-11-4.
     */
    private String mChannelFrom = "un_known";
    /**
     * 一级用户类型
     * created by mayunlong.
     * created date 16-11-4.
     */
    private String mFirstUserType = "organic";
    /**
     * 二级用户类型
     * created by mayunlong.
     * created date 16-11-4.
     */
    private int mSecondUserType = -1;
    /**
     * 买量SDK是否已经成功确认用户身份
     * created by mayunlong.
     * created date 16-11-10.
     */
    private boolean isSuccessCheck = false;
    /**
     * campaign的值
     *
     * @return
     */
    private String campaign = "null";
    /**
     * campaignId的值
     *
     * @return
     */
    private String mCampaignId = "null";

    /**
     * 判断买量SDK是否已经成功确认用户身份
     *
     * @return
     */
    public boolean isSuccessCheck() {
        return isSuccessCheck;
    }

    public void setSuccessCheck(boolean successCheck) {
        isSuccessCheck = successCheck;
    }

    /**
     * 判断是否买量用户(包含APK买量)
     *
     * @return
     */
    public boolean isUserBuy() {
        if (mFirstUserType.equals("userbuy") || mFirstUserType.equals("apkbuy")) {
            return true;
        }
        return false;
    }

    /**
     * 判断是否带量用户
     *
     * @return
     */
    public boolean isWithCount() {
        if (mFirstUserType.equals("withCount")) {
            return true;
        }
        return false;
    }


    /**
     * 判断是否自然用户
     *
     * @return
     */
    public boolean isOrganic() {
        if (mFirstUserType.equals("organic")) {
            return true;
        }
        return false;
    }

    /**
     * 判断是否apk用户
     *
     * @return
     */
    public boolean isApkBuy() {
        if (mFirstUserType.equals("apkbuy")) {
            return true;
        }
        return false;
    }

    /**
     * 获取二级用户类型，充电锁，广告SDK等调用该接口，去服务器获取相关配置
     * 备注：二级用户类型请参照 http://wiki.3g.net.cn/pages/viewpage.action?pageId=18781210
     *
     * @return
     */
    public int getSecondUserType() {
        return mSecondUserType;
    }

    public void setSecondUserType(int sencondType) {
        this.mSecondUserType = sencondType;
    }

    /**
     * 获取一级用户类型，分别为买量，带量，自然，apk买量
     *
     * @return
     */
    public String getFirstUserType() {
        return mFirstUserType;
    }

    public void setFirstUserType(String firstUserType) {
        mFirstUserType = firstUserType;
    }

    /**
     * 获取买量渠道判断的来源
     *
     * @return
     */
    public String getChannelFrom() {
        return mChannelFrom;
    }

    public void setChannelFrom(String channelFrom) {
        this.mChannelFrom = channelFrom;
    }

    /**
     * 获取买量渠道名称的接口
     *
     * @return
     */
    public String getBuyChannel() {
        return mBuyChannel;
    }

    public void setBuyChannel(String buyChannel) {
        this.mBuyChannel = buyChannel;
    }

    /**
     * 获取Campaign的值
     *
     * @return
     */
    public String getCampaign() {
        return campaign;
    }

    public void setCampaign(String campaign) {
        this.campaign = campaign;
    }

    /**
     * 获取CampaignId的值
     *
     * @return
     */
    public String getCampaignId() {
        return mCampaignId;
    }

    public void setCampaignId(String campaignId) {
        mCampaignId = campaignId;
    }


    @Override
    public String toString() {
        return "buyChannel:[" + mBuyChannel + "]" + "channelFrom:[" + mChannelFrom + "]"
                + "UserType:[" + mFirstUserType + "]" + "JuniorUserType:[" + mSecondUserType + "]，是否成功获取用户身份 :" + isSuccessCheck;
    }

    public String toJsonStr() {
        JSONObject object = new JSONObject();
        try {

            object.put("buyChannel", mBuyChannel == null ? "" : mBuyChannel);
            object.put("channelFrom", mChannelFrom == null ? "" : mChannelFrom);
            object.put("firstUserType", mFirstUserType == null ? "" : mFirstUserType);
            object.put("userType", mSecondUserType);
            object.put("isSuccessCheck", isSuccessCheck);
            object.put("campaign", campaign);
            object.put("campaignId", mCampaignId);
            String jsonString = object.toString();
            return jsonString;
        } catch (JSONException e) {
            e.printStackTrace();
            return null;
        }

    }

    public BuyChannelBean jsonStr2Bean(String jsonString) {
        if (TextUtils.isEmpty(jsonString)) {
            return null;
        }
        try {
            JSONObject object = new JSONObject(jsonString);
            BuyChannelBean buyChannelBean = new BuyChannelBean();
            buyChannelBean.setChannelFrom(object.optString("channelFrom"));
            buyChannelBean.setBuyChannel(object.optString("buyChannel"));
            buyChannelBean.setFirstUserType(object.optString("firstUserType"));
            buyChannelBean.setSecondUserType(Integer.parseInt(object.optString("userType")));
            buyChannelBean.setSuccessCheck(Boolean.parseBoolean(object.optString("isSuccessCheck")));
            buyChannelBean.setCampaign(object.optString("campaign"));
            buyChannelBean.setCampaignId(object.optString("campaignId"));
            return buyChannelBean;
        } catch (JSONException e) {
            e.printStackTrace();
            return null;
        }
    }


}


