package com.jiubang.commerce.buychannel.buyChannel.bean;

import android.text.TextUtils;

import org.json.JSONException;
import org.json.JSONObject;

/**
 * Created by mayunlong on 16-11-10.
 */

public class Statistics19Bean {
    /**
     * 渠道号,19协议也需要使用
     */
    public int mChannel = 200;
    /**
     * 是否付费用户，用于19协议
     */
    public boolean mIsPay = false;
    /**
     * 19协议里的正版标识
     */
    public String mP19Key = "";
    /**
     * 是否需要上传root信息,用于19协议
     */
    public boolean mNeedRootInfo = false;

    /**
     * 是否老用户，用于买量SDK旧数据的兼容
     * 判断老用户的标准为：应用是否第一次启动，不是第一次启动既为老用户
     */
    public boolean mIsOldUser;

    public Statistics19Bean(int channel, boolean isOldUser, String p19Key, boolean needRootInfo, boolean pay) {
        mChannel = channel;
        mIsOldUser = isOldUser;
        mP19Key = p19Key;
        mNeedRootInfo = needRootInfo;
        mIsPay = pay;
    }


    public String toJsonStr() {
        JSONObject object = new JSONObject();
        try {

            object.put("mChannel", mChannel);
            object.put("mIsPay", mIsPay);
            object.put("mP19Key", mP19Key);
            object.put("mNeedRootInfo", mNeedRootInfo);
            object.put("mIsOldUser", mIsOldUser);
            String jsonString = object.toString();
            return jsonString;
        } catch (JSONException e) {
            e.printStackTrace();
            return null;
        }

    }

    public static Statistics19Bean jsonStr2Bean(String jsonString) {
        if (TextUtils.isEmpty(jsonString)) {
            return null;
        }
        try {
            JSONObject object = new JSONObject(jsonString);
            Statistics19Bean statistics19Bean = new Statistics19Bean(object.optInt("mChannel"), object.optBoolean("mIsOldUser"),
                    object.optString("mP19Key"), object.optBoolean("mNeedRootInfo"), object.optBoolean("mIsPay"));


            return statistics19Bean;
        } catch (JSONException e) {
            e.printStackTrace();
            return null;
        }
    }


}
