/*
 * Copyright (c) 2016. Lorem ipsum dolor sit amet, consectetur adipiscing elit.
 * Morbi non lorem porttitor neque feugiat blandit. Ut vitae ipsum eget quam lacinia accumsan.
 * Etiam sed turpis ac ipsum condimentum fringilla. Maecenas magna.
 * Proin dapibus sapien vel ante. Aliquam erat volutpat. Pellentesque sagittis ligula eget metus.
 * Vestibulum commodo. Ut rhoncus gravida arcu.
 */

package com.jiubang.commerce.buychannel.buyChannel.bean;

import android.text.TextUtils;

import org.json.JSONObject;

/**
 * 请求用户标签相关参数
 * Created by mayunlong on 16-11-22.
 */

public class UserTagParam {
    //go系列软件用户id
    public final String mGoId;
    //产品id, 每个产品都不一样，详见{@link #PRODUCT_ID_ZERO_LAUNCHER_APPCENTER}等值
    public final String mGoogleId;
    //渠道号(大于0)
    public final String mChannel;
    //productKey
    public final String mProductKey;
    //accessKey
    public final String mAccessKey;

    public UserTagParam(String goId, String googleId, String channel, String productKey, String accessKey) {
        mGoId = goId;
        mGoogleId = googleId;
        mChannel = channel;
        mProductKey = productKey;
        mAccessKey = accessKey;

    }


    public String toJsonStr() {
        JSONObject object = new JSONObject();
        try {
            object.put("goId", mGoId == null ? "" : mGoId);
            object.put("googleId", mGoogleId == null ? "" : mGoogleId);
            object.put("channel", mChannel == null ? "" : mChannel);
            object.put("productKey", mProductKey == null ? "" : mProductKey);
            object.put("accessKey", mAccessKey == null ? "" : mAccessKey);
            String jsonString = object.toString();
            return jsonString;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }

    }

    public static UserTagParam jsonStr2Bean(String jsonString) {
        if (TextUtils.isEmpty(jsonString)) {
            return null;
        }
        try {
            JSONObject object = new JSONObject(jsonString);
            String goId = object.optString("goId");
            String googleId = object.optString("googleId");
            String channel = object.optString("channel");
            String productKey = object.optString("productKey");
            String accessKey = object.optString("accessKey");
            UserTagParam userTagParam = new UserTagParam(goId, googleId, channel, productKey, accessKey);

            return userTagParam;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

}
