package com.jiubang.commerce.buychannel.buyChannel.database;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;

import com.jb.ga0.commerce.util.io.DataBaseHelper;
import com.jiubang.commerce.buychannel.BuySdkConstants;

import java.util.ArrayList;

/**
 * Created by mayunlong on 17-3-7.
 */

public class BuychannelDbHelpler extends DataBaseHelper {

    private static final String LOG_TAG = BuySdkConstants.LOG_TAG;
    private static BuychannelDbHelpler sInstance;
    public final static int DB_VERSION_MAX = 1; //当前版本号
    private final static String DATABASE_NAME = "buychannelsdk.db"; //数据库名称

    private BuychannelDbHelpler(Context context) {
        super(context, DATABASE_NAME, DB_VERSION_MAX);
    }

    public static BuychannelDbHelpler getInstance(Context context) {
        if (sInstance == null) {
            sInstance = new BuychannelDbHelpler(context);
        }
        return sInstance;
    }


    @Override
    public int getDbCurrentVersion() {
        return DB_VERSION_MAX;
    }

    @Override
    public String getDbName() {
        return DATABASE_NAME;
    }

    @Override
    public void onCreateTables(SQLiteDatabase db) {
        //建表
        db.execSQL(StaticsTable.CREATE_STATICS_TABLE);
    }

    @Override
    public void onAddUpgrades(ArrayList<UpgradeDB> upgrades) {

    }
}
