package com.jiubang.commerce.buychannel.buyChannel.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.util.Log;

import com.jb.ga0.commerce.util.io.DataBaseHelper;
import com.jb.ga0.commerce.util.io.DatabaseException;
import com.jiubang.commerce.buychannel.BuySdkConstants;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by mayunlong on 17-3-7.
 */

public class StaticsTable {
    public static final String TABLE_NAME = "buychannel_45_table";
    public static final String STATICS45 = "statics45";

    public static final String CREATE_STATICS_TABLE = "CREATE TABLE " + DataBaseHelper.IF_NOT_EXISTS + " " + TABLE_NAME + " ("
            + STATICS45 + " " + DataBaseHelper.TYPE_TEXT + " " + DataBaseHelper.NOT_NULL + ")";


    /**
     * 插入45协议
     *
     * @param dataBaseHelper
     * @param buffer45
     */
    public static void insert(DataBaseHelper dataBaseHelper, String buffer45) {
        if (dataBaseHelper == null || buffer45 == null) {
            return;
        }
        try {
            ContentValues contentValues = new ContentValues();
            contentValues.put(STATICS45, buffer45);
            dataBaseHelper.insert(TABLE_NAME, contentValues);
            Log.i(BuySdkConstants.LOG_TAG, "[StaticsTable::insert]:" + buffer45);
        } catch (Exception e) {
            e.printStackTrace();
        }


    }


    /**
     * 查询数据库中所有数据并加载到缓存中
     *
     * @param dataBaseHelper
     * @return
     */
    public static List<String> queryAll(DataBaseHelper dataBaseHelper) {
        if (dataBaseHelper == null) {
            return null;
        }
        List<String> statics45List = new ArrayList<String>();
        StringBuffer whereBuffer = new StringBuffer(" 1=1");
        Cursor cursor = dataBaseHelper.query(StaticsTable.TABLE_NAME, new String[]{STATICS45},
                whereBuffer.toString(), null, null, null, null);
        try {
            if (cursor != null && cursor.moveToFirst()) {

                do {

                    statics45List.add(cursor.getString(cursor.getColumnIndex(STATICS45)));
                    Log.i(BuySdkConstants.LOG_TAG, "[StaticsTable::queryAll] ");
                } while (cursor.moveToNext());
                cursor.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (cursor != null) {
                cursor.close();
            }
        }

        return statics45List;
    }


    public static void deleteAll(DataBaseHelper dataBaseHelper) {
        if (dataBaseHelper == null) {
            return;

        }
        int count = 0;
        try {
            count = dataBaseHelper.delete(TABLE_NAME, STATICS45, null);
            Log.i(BuySdkConstants.LOG_TAG, "[StaticsTable::deleteAll] ");
        } catch (DatabaseException e) {
            e.printStackTrace();
        }
    }

}
