package com.jiubang.commerce.buychannel.buyChannel.manager;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;

import com.gau.utils.net.IConnectListener;
import com.gau.utils.net.request.THttpRequest;
import com.gau.utils.net.response.IResponse;
import com.jb.ga0.commerce.util.LogUtils;
import com.jb.ga0.commerce.util.thread.CustomThreadExecutorProxy;
import com.jiubang.commerce.buychannel.AppsFlyerProxy;
import com.jiubang.commerce.buychannel.BuyChannelDataMgr;
import com.jiubang.commerce.buychannel.BuyChannelSetting;
import com.jiubang.commerce.buychannel.BuySdkConstants;
import com.jiubang.commerce.buychannel.BuySdkInitParams;
import com.jiubang.commerce.buychannel.buyChannel.Interface.OldUserTableListenner;
import com.jiubang.commerce.buychannel.buyChannel.Interface.OldUserTagListenner;
import com.jiubang.commerce.buychannel.buyChannel.Statistics.UserStatistics;
import com.jiubang.commerce.buychannel.buyChannel.bean.BuyChannelTypeContans;
import com.jiubang.commerce.buychannel.buyChannel.bean.UserTypeInfo;
import com.jiubang.commerce.buychannel.buyChannel.utils.RequestDataUtils;
import com.jiubang.commerce.buychannel.buyChannel.utils.TextUtils;
import com.jiubang.commerce.utils.StringUtils;
import com.jiubang.commerce.utils.SystemUtils;

import org.apache.http.HttpResponse;
import org.json.JSONObject;


/**
 * Created by mayunlong on 16-10-25.
 */

public class OldUserUpHelper {
    private static OldUserUpHelper sInstance;
    private Context mContext;
    private final ConnectionChangeReceiver mConnectionChangeReceiver;
    private boolean mReceiverTag = false;   //广播接受者标识

    private String mCheckType = null;

    private SharedPreferences mSp;
    private Runnable mOldUserTask;
    private BuyChannelDataMgr mBuyChannelDataMgr;

    public static OldUserUpHelper getInstance(Context context) {
        if (sInstance == null) {
            synchronized (OldUserUpHelper.class) {
                if (sInstance == null) {
                    sInstance = new OldUserUpHelper(context);
                }
            }
        }
        return sInstance;
    }

    private OldUserUpHelper(Context context) {
        mContext = context != null ? context.getApplicationContext() : null;
        mConnectionChangeReceiver = new ConnectionChangeReceiver();
        mSp = BuyChannelDataMgr.getInstance(context).getSharedPreferences(context);
    }

   /* public void updateOldUser(boolean isOldUser) {
        this.isOldUser = isOldUser;
        checkOldUser();
    }*/

    public void updateOldUser(String checkType) {
        this.mCheckType = checkType;
        mSp.edit().putString(BuySdkConstants.CHECK_SERVER_TYPE, checkType).commit();
        checkOldUser();
    }

    private void checkUserTable(String checkType) {
        this.mCheckType = checkType;
        mSp.edit().putString(BuySdkConstants.CHECK_SERVER_TYPE, checkType).commit();
        startConnectionReceiver();
    }

    private void startConnectionReceiver() {
        if (!mReceiverTag) {
            IntentFilter filter = new IntentFilter();
            mReceiverTag = true;    //标识值 赋值为 true 表示广播已被注册
            filter.addAction(ConnectivityManager.CONNECTIVITY_ACTION);
            mContext.registerReceiver(mConnectionChangeReceiver, filter);
        }
    }


    /*public void refreshNewUserTag(boolean isOldUser) {
        this.isOldUser = isOldUser;
        startConnectionReceiver();
    }*/

    public void refreshNewUserTag(String checkType) {
        this.mCheckType = checkType;
        mSp.edit().putString(BuySdkConstants.CHECK_SERVER_TYPE, checkType).commit();
        startConnectionReceiver();
    }

    public void checkUserTagAfterUserTable(String checkType) {
        this.mCheckType = checkType;
        mSp.edit().putString(BuySdkConstants.CHECK_SERVER_TYPE, checkType).commit();
        startConnectionReceiver();
    }

    private void checkOldUser() {
        if (mOldUserTask != null) {
            CustomThreadExecutorProxy.getInstance().cancel(mOldUserTask);
            mOldUserTask = null;
        }

        mOldUserTask = new Runnable() {
            @Override
            public void run() {
                startConnectionReceiver();
                mOldUserTask = null;
            }
        };
        LogUtils.i(BuySdkConstants.LOG_TAG, "[OldUserUpHelper::checkOldUser] 3s后，去核实老用户身份 ");
        // 为了不影响启动速度，等待3s后，去核实老用户身份
        CustomThreadExecutorProxy.getInstance().runOnMainThread(mOldUserTask, BuySdkConstants.CHECK_OLD_DELAY);
    }

    /**
     * 进行网络监听
     * created by mayunlong.
     * created date 16-10-25.
     */
    private class ConnectionChangeReceiver extends BroadcastReceiver {

        private String mOldBuyChannel;

        @Override
        public void onReceive(Context context, Intent intent) {
            if (!ConnectivityManager.CONNECTIVITY_ACTION.equals(intent
                    .getAction())) {
                return;
            }

            ConnectivityManager connectivityManager = (ConnectivityManager) context
                    .getSystemService(Context.CONNECTIVITY_SERVICE);
            NetworkInfo mobNetInfo = connectivityManager
                    .getNetworkInfo(ConnectivityManager.TYPE_MOBILE);
            NetworkInfo wifiNetInfo = connectivityManager
                    .getNetworkInfo(ConnectivityManager.TYPE_WIFI);


            //LG手机有BUG，广播发多次，所以通过时间差过滤掉
            Long lastTime = mSp.getLong(BuySdkConstants.REPEAT_NETWORK, 0);
            if (System.currentTimeMillis() - lastTime < 5 * 1000) {
                mSp.edit().putLong(BuySdkConstants.REPEAT_NETWORK, System.currentTimeMillis()).commit();
                return;
            }
            mSp.edit().putLong(BuySdkConstants.REPEAT_NETWORK, System.currentTimeMillis()).commit();

            LogUtils.i(BuySdkConstants.LOG_TAG, "网络状态变化--->");
            if ((mobNetInfo != null && mobNetInfo.isConnected())
                    || wifiNetInfo != null && wifiNetInfo.isConnected()) {
                LogUtils.i(BuySdkConstants.LOG_TAG, "网络状态变化--->成功联网");

                String checkType = mSp.getString(BuySdkConstants.CHECK_SERVER_TYPE, null);
                mCheckType = checkType != null ? checkType : mCheckType;

                if (TextUtils.isEmpty(mCheckType)) {
                    return;
                }

                if (mCheckType.equals(BuySdkConstants.CHECK_USERTAG_OLDUSER)) {

                    //老用户检查标签接口的逻辑
                    String oldUserMsg = mSp.getString(BuySdkConstants.OLD_USER_MSG, null);
                    mOldBuyChannel = null;

                    if (!TextUtils.isEmpty(oldUserMsg)) {
                        String[] oldMsg = oldUserMsg.split(BuySdkConstants.SEPARATOR);
                        if (oldMsg.length > 1) {
                            mOldBuyChannel = oldMsg[0];
                            LogUtils.i(BuySdkConstants.LOG_TAG, "[OldUserUpHelper::ConnectionChangeReceiver] buyChannel:" +
                                    oldMsg[0]);
                        }

                        //当网络可用的时候，立即去查询用户类型
                        checkOldUser(context, mOldBuyChannel);
                    }
                } else if (mCheckType.equals(BuySdkConstants.CHECK_USERTAG_NEWUSER)) {
                    //新用户中自然或非自然带量检查标签接口的逻辑
                    checkNewUserTag();
                } else if (mCheckType.equals(BuySdkConstants.CHECK_USERTABLE_OLDUSER)) {
                    checkUnkownOldUser(mContext, mOldBuyChannel, new OldUserTableListenner() {
                        @Override
                        public void requestUserTableSuccess() {
                            stopConnectionStateUpdate();
                            //成功后把checkType恢复为空
                            mSp.edit().putString(BuySdkConstants.CHECK_SERVER_TYPE, null).commit();
                        }
                    });
                } else if (mCheckType.equals(BuySdkConstants.CHECK_USERTAG_USERTABLE_OLDUSER)) {
                    checkUserTagAfterUserTable(mContext, mOldBuyChannel);
                }


            }
        }
    }

    private void checkNewUserTag() {

        new Thread(new Runnable() {
            private String mAssociatedObj;

            @Override
            public void run() {

                UserTypeInfo.SecondUserType secondUserType = UserTagHelper.getInstance(mContext).requestUserTag(new OldUserTagListenner() {
                    @Override
                    public void requestUserTagSuccess() {
                        stopConnectionStateUpdate();
                        //成功后把checkType恢复为空
                        mSp.edit().putString(BuySdkConstants.CHECK_SERVER_TYPE, null).commit();
                    }
                }, true);

                //设置最近一次的时间
                BuyChannelDataMgr.getInstance(mContext).setLastCheckTime(System.currentTimeMillis());

                LogUtils.i(BuySdkConstants.LOG_TAG, "记录最近一次server-check为当前时间：" + System.currentTimeMillis());

                //如果第一次时间为空，还要设置当前时间为第一次时间
                if (BuyChannelDataMgr.getInstance(mContext).getFirstCheckTime() == 0) {
                    BuyChannelDataMgr.getInstance(mContext).setFirstCheckTime(System.currentTimeMillis());

                    LogUtils.i(BuySdkConstants.LOG_TAG, "如果第一次时间为空，设置当前时间为第一次时间：" + System.currentTimeMillis());

                }

                UserTypeInfo.FirstUserType firstUserType = UserTypeInfo.FirstUserType.userbuy;
                String buyChannel = BuySdkConstants.BUYCHANNEL_TAG_USERBUY;


                if (secondUserType == null) {
                    LogUtils.i(BuySdkConstants.LOG_TAG, "新用户，通过标签找回为非买量或带量用户，不覆盖数据");

                    return;
                }
                if (secondUserType.equals(UserTypeInfo.SecondUserType.WITHCOUNT_ORGNIC)) {
                    firstUserType = UserTypeInfo.FirstUserType.withCount;
                    buyChannel = BuySdkConstants.BUYCHANNEL_TAG_WITHCOUNT;
                    mAssociatedObj = UserStatistics.get45AssociatedEmptyOther(buyChannel);
                }
                if (secondUserType.equals(UserTypeInfo.SecondUserType.APK_USERBUY)) {
                    firstUserType = UserTypeInfo.FirstUserType.apkbuy;
                }
                String newUserBefore = mSp.getString(BuySdkConstants.NEW_USER_BEFORE, null);
                String tag = newUserBefore + "_usertag_newuser";

                String conversionDataJsonStr = mSp.getString(BuySdkConstants.CONVERSIONDATA, null);
                String referrer = mSp.getString(BuySdkConstants.REFERRER, null);


                mAssociatedObj = UserStatistics.get45AssociatedObjOther(buyChannel, null, null, null);
                String campaign = mSp.getString(BuySdkConstants.CAMPAIGN, null);
                String campaignId = mSp.getString(BuySdkConstants.CAMPAIGN_ID, null);
                BuyChannelSetting.getInstance(mContext).setBuyChannel(buyChannel, BuyChannelSetting.ChannelFrom.from_usertag,
                        firstUserType, secondUserType, campaign, campaignId, mAssociatedObj, null, conversionDataJsonStr, referrer, tag, null);


            }
        }).start();
    }

    /**
     * 在查询买量表之后，继续查询用户标签接口的方法
     * created by mayunlong.
     * created date 17-1-10.
     */
    private void checkUserTagAfterUserTable(final Context context, final String buyChannel) {

        new Thread(new Runnable() {
            private String mAssociatedObj;

            @Override
            public void run() {

                UserTypeInfo.FirstUserType firstUserType = null;
                UserTypeInfo.SecondUserType secondUserType = UserTagHelper.getInstance(context).requestUserTag(new OldUserTagListenner() {
                    @Override
                    //说明获取老用户标签成功，不再进行网络监听了
                    public void requestUserTagSuccess() {
                        stopConnectionStateUpdate();
                        //成功后把checkType恢复为空
                        mSp.edit().putString(BuySdkConstants.CHECK_SERVER_TYPE, null).commit();

                    }
                }, false);
                mBuyChannelDataMgr = BuyChannelDataMgr.getInstance(context);

                if (secondUserType == null) {
                    //说明用户标签查不到
                    LogUtils.i(BuySdkConstants.LOG_TAG, "[OldUserUpHelper::checkUserTagAfterUserTable] 通过标签无法识别老用户身份");

                    mSp.edit().putLong(BuySdkConstants.REPEAT_NETWORK, 0).commit();

                    return;
                } else if (secondUserType.equals(UserTypeInfo.SecondUserType.WITHCOUNT_ORGNIC)) {
                    //自然带量

                    return;

                } else if (secondUserType.equals(UserTypeInfo.SecondUserType.APK_USERBUY)) {
                    //APK买量
                    firstUserType = UserTypeInfo.FirstUserType.apkbuy;
                    ServerCheckHelper.getInstance(mContext).cancelCheckUserTag();
                } else {
                    //买量用户
                    firstUserType = UserTypeInfo.FirstUserType.userbuy;
                    ServerCheckHelper.getInstance(mContext).cancelCheckUserTag();
                }


                mAssociatedObj = UserStatistics.get45AssociatedObjOther(buyChannel, null, null, null);

                String conversionDataJsonStr = mSp.getString(BuySdkConstants.CONVERSIONDATA, null);

                String campaign = mSp.getString(BuySdkConstants.CAMPAIGN, null);
                String campaignId = mSp.getString(BuySdkConstants.CAMPAIGN_ID, null);


                mBuyChannelDataMgr.setBuyChannelBean(buyChannel, BuyChannelSetting.ChannelFrom.from_oldUser_usertag, firstUserType, secondUserType, conversionDataJsonStr, null, campaign, campaignId);
                BuySdkInitParams mInitParams = AppsFlyerProxy.getInstance().getInitParams();
                UserStatistics.upload45(mContext, mInitParams.mIsGoKeyboard, mInitParams.mP45FunId,
                        mAssociatedObj, null, null, String.valueOf(secondUserType.getValue()), "usertable_olduser_usertag", null, false);
            }
        }).start();

    }

    /**
     * 去服务器检查老用户标签的方法
     * created by mayunlong.
     * created date 16-10-25.
     */
    private void checkOldUser(final Context context, final String buyChannel) {

        new Thread(new Runnable() {
            @Override
            public void run() {

                UserTypeInfo.FirstUserType firstUserType = null;
                UserTypeInfo.SecondUserType secondUserType = UserTagHelper.getInstance(context).requestUserTag(new OldUserTagListenner() {
                    @Override
                    //说明获取老用户标签成功，不再进行网络监听了
                    public void requestUserTagSuccess() {
                        stopConnectionStateUpdate();
                        //成功后把checkType恢复为空
                        mSp.edit().putString(BuySdkConstants.CHECK_SERVER_TYPE, null).commit();
                    }
                }, false);
                mBuyChannelDataMgr = BuyChannelDataMgr.getInstance(context);
                /*//设置最近一次的时间
                BuyChannelDataMgr.getInstance(context).setLastCheckTime(System.currentTimeMillis());

                LogUtils.i(BuySdkConstants.LOG_TAG, "记录最近一次server-check为当前时间：" + System.currentTimeMillis());

                //如果第一次时间为空，还要设置当前时间为第一次时间
                if (BuyChannelDataMgr.getInstance(context).getFirstCheckTime() == 0) {
                    BuyChannelDataMgr.getInstance(context).setFirstCheckTime(System.currentTimeMillis());

                    LogUtils.i(BuySdkConstants.LOG_TAG, "如果第一次时间为空，设置当前时间为第一次时间：" + System.currentTimeMillis());

                }*/
                if (secondUserType == null) {
                    //说明用户标签查不到
                    LogUtils.i(BuySdkConstants.LOG_TAG, "[OldUserUpHelper::checkOldUser] 通过标签无法识别老用户身份," +
                            "判断为未知老用户类型,需要去查买量表");
                    //需要去查买量表
                    //checkUnkownOldUser(context, buyChannel);
                    //测试用，睡眠3S
                   /* try {
                        LogUtils.i(BuySdkConstants.LOG_TAG, "[OldUserUpHelper::checkOldUser] 延迟3S" +
                                "去查买量表");
                        Thread.sleep(3000);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }*/
                    mSp.edit().putLong(BuySdkConstants.REPEAT_NETWORK, 0).commit();
                    checkUserTable(BuySdkConstants.CHECK_USERTABLE_OLDUSER);
                    return;
                } else if (secondUserType.equals(UserTypeInfo.SecondUserType.WITHCOUNT_ORGNIC)) {
                    //自然带量
                    firstUserType = UserTypeInfo.FirstUserType.withCount;

                } else if (secondUserType.equals(UserTypeInfo.SecondUserType.APK_USERBUY)) {
                    //APK买量
                    firstUserType = UserTypeInfo.FirstUserType.apkbuy;
                } else {
                    //买量用户
                    firstUserType = UserTypeInfo.FirstUserType.userbuy;
                }


                mBuyChannelDataMgr.setBuyChannelBean(buyChannel, BuyChannelSetting.ChannelFrom.from_oldUser, firstUserType, secondUserType, null, null, null, null);

            }


        }).start();
    }


    /**
     * 通过买量表去核实老用户身份
     * created by mayunlong.
     * created date 16-11-10.
     */
    private void checkUnkownOldUser(final Context context, final String buyChannel, final OldUserTableListenner listenner) {
        //获取安卓id
        String aid = StringUtils.toString(SystemUtils.getAndroidId(context));
        String cid = mSp.getString(BuySdkConstants.PRODUCT_ID, null);

        RequestDataUtils.requestBuyChannelType(context, cid, aid, buyChannel, new IConnectListener() {
            @Override
            public void onFinish(THttpRequest tHttpRequest, IResponse iResponse) {
                JSONObject datasJson = null;
                try {
                    datasJson = new JSONObject(StringUtils
                            .toString(iResponse.getResponse()));
                } catch (Exception e) {
                    e.printStackTrace();
                }
                // 解析返回Json数据
                String buyChannelType = datasJson != null ? datasJson
                        .optString("buychanneltype") : null;
                if (TextUtils.isEmpty(buyChannelType)) {
                    //服务器返回的数据为空
                    LogUtils.i(BuySdkConstants.LOG_TAG, "服务器返回的数据为空");
                    return;
                }
                LogUtils.d(BuySdkConstants.LOG_TAG, "服务器返回的数据成功，buyChannelType=" + buyChannelType);

                listenner.requestUserTableSuccess();
                UserTypeInfo.FirstUserType firstUserType = null;
                UserTypeInfo.SecondUserType secondUserType = null;

                //服务器返回不为空
                if (Integer.parseInt(buyChannelType) > 1) {
                    firstUserType = UserTypeInfo.FirstUserType.userbuy;
                    //大于1为买量用户
                    switch (buyChannelType) {
                        case BuyChannelTypeContans.TYPE_NOT_GP:
                            firstUserType = UserTypeInfo.FirstUserType.apkbuy;
                            secondUserType = UserTypeInfo.SecondUserType.APK_USERBUY;
                            LogUtils.d(BuySdkConstants.LOG_TAG, "买量表判断为非GP渠道，判定为APK买量，buyChannelType=" + buyChannelType);
                            break;
                        case BuyChannelTypeContans.TYPE_GP:
                            secondUserType = UserTypeInfo.SecondUserType.GA_USERBUY;
                            LogUtils.d(BuySdkConstants.LOG_TAG, "买量表判断为GP渠道，判定为GA买量，buyChannelType=" + buyChannelType);
                            break;
                        case BuyChannelTypeContans.TYPE_FB:
                            secondUserType = UserTypeInfo.SecondUserType.FB_AUTO;
                            LogUtils.d(BuySdkConstants.LOG_TAG, "买量表判断为FB买量，判定为FB自投，buyChannelType=" + buyChannelType);
                            break;
                        case BuyChannelTypeContans.TYPE_ADWORDS:
                            secondUserType = UserTypeInfo.SecondUserType.ADWORDS_AUTO;
                            LogUtils.d(BuySdkConstants.LOG_TAG, "买量表判断为Adwords买量，判定为Adwords自投，buyChannelType=" + buyChannelType);
                            break;
                        default:
                            break;
                    }
                    String associatedObj = UserStatistics.get45AssociatedObjOther(buyChannel, null, null, null);


                    BuySdkInitParams mInitParams = AppsFlyerProxy.getInstance().getInitParams();
                    UserStatistics.upload45(mContext, mInitParams.mIsGoKeyboard, mInitParams.mP45FunId,
                            associatedObj, null, null, String.valueOf(secondUserType.getValue()), "organic_usertable_olduser", null, false);


                } else if (Integer.parseInt(buyChannelType) <= 1) {


                    //小于等于1为自然,不上传45协议
                    firstUserType = UserTypeInfo.FirstUserType.organic;
                    secondUserType = UserTypeInfo.SecondUserType.GP_ORGNIC;
                    LogUtils.d(BuySdkConstants.LOG_TAG, "买量表判断为自然，判定为自然，buyChannelType=" + buyChannelType);
                }
                mBuyChannelDataMgr.setBuyChannelBean(buyChannel, BuyChannelSetting.ChannelFrom.from_oldUser, firstUserType, secondUserType, null, null, null, null);
                //查询买量表之后，要定时２天，每８小时查询一次用户标签接口
                ServerCheckHelper.getInstance(mContext).startCheckUserTag(BuySdkConstants.INTERVAL_SERVER_CHECKTIME);

            }

            @Override
            public void onException(THttpRequest tHttpRequest, int i) {

            }

            @Override
            public void onStart(THttpRequest tHttpRequest) {

            }

            @Override
            public void onException(THttpRequest tHttpRequest, HttpResponse httpResponse, int i) {

            }


        });


    }


    /**
     * 取消网络监听
     * created by mayunlong.
     * created date 16-10-25.
     */
    private void stopConnectionStateUpdate() {
        if (mConnectionChangeReceiver != null && mReceiverTag) {
            mReceiverTag = false;   //Tag值 赋值为false 表示该广播已被注销
            mContext.unregisterReceiver(mConnectionChangeReceiver);
        }


    }


}
