package com.jiubang.commerce.buychannel.buyChannel.utils;

import android.content.Context;

import com.gau.utils.net.IConnectListener;
import com.gau.utils.net.request.THttpRequest;
import com.jb.ga0.commerce.util.LogUtils;
import com.jb.ga0.commerce.util.http.AdvertJsonOperator;
import com.jiubang.commerce.ad.http.AdSdkRequestHeader;
import com.jiubang.commerce.ad.http.AdvertHttpAdapter;
import com.jiubang.commerce.buychannel.BuySdkConstants;

import java.util.HashMap;

/**
 * Created by mayunlong on 16-11-10.
 */

public class RequestDataUtils {

    public static void requestBuyChannelType(Context context, String cid, String aid, String buychannel, IConnectListener listener) {
        //开始请求数据
        THttpRequest httpRequest = null;
        try {
            httpRequest = new THttpRequest(AdSdkRequestHeader.getBuyChannelTypeUrl(), listener);
        } catch (Exception e) {
            LogUtils.e(BuySdkConstants.LOG_TAG, "requestBuyChannelType(error, " + (e != null ? e.getMessage() : "==") + ")");
        }
        if (httpRequest != null) {
            HashMap<String, String> maps = new HashMap<String, String>();
            //设置cid
            maps.put(AdSdkRequestHeader.PRODUCT_ID, cid);
            //设置aid
            maps.put(AdSdkRequestHeader.ANDROID_ID, aid);
            //设置buychannel
            maps.put(AdSdkRequestHeader.BUY_CHANNEL, buychannel);
            //设置rd
            maps.put("rd", "1");
            /*//对提交的数据进行处理,默认0:无处理;1:采用gzip压缩(请求上传的数据量比较大[大于10k]时使用);2:BASE64加密(涉及到采集用户本地数据的时候使用);
            maps.put("handle", "0");
            //server是否对返回的数据进行处理::->默认1:采用gzip压缩;0:无处理；
            maps.put("shandle", "1");*/
            httpRequest.setParamMap(maps);
            httpRequest.setProtocol(THttpRequest.PROTOCOL_POST);
            //超时设为10s
            httpRequest.setTimeoutValue(10000);
            httpRequest.setRequestPriority(Thread.MAX_PRIORITY);
            httpRequest.setOperator(new AdvertJsonOperator(false));
            //httpRequest.setNetRecord(new AppGameNetRecord(mContext, false));
            //请求买量用户数据不需要使用异步(必须要使用同步)
            AdvertHttpAdapter.getInstance(context).addTask(httpRequest, true);

        } else {

            LogUtils.d(BuySdkConstants.LOG_TAG, "requestBuyChannelType(error, httpRequest is null)");
        }
    }
}
