package com.jiubang.core.message;

import java.util.List;

/**
 * 消息处理器接口
 * 
 * @author yuankai
 * @version 1.0
 */
public interface IMessageHandler
{
	/**
	 * 消息处理方法
	 * @param type 消息类型(UI线程或非UI线程)
	 * @param msgId 消息ID
	 * @param param 辅助参数
	 * @param object 传递过来的辅助对象
	 * @param objects 传递过来的对象列表
	 * @return 是否处理
	 */
	@SuppressWarnings( {"rawtypes" })
	public boolean handleMessage(Object who, int msgId, int param, Object ...object);
	
	/**
	 * 获取消息处理ID
	 * @return 处理者ID
	 */
	public int getMsgHandlerId();
}
