package com.jiubang.core.message;

import java.util.LinkedList;

/**
 * 队列管理器
 * 
 * @author yuankai
 * @version 1.0
 */
public class Queue
{
	protected LinkedList<Object> mList;
	
	/**
	 * 队列构造方法
	 */
	public Queue()
	{
		mList = new LinkedList<Object>();
	}
	
	/**
	 * 队列是否为空
	 * @return 是否为空
	 */
	public boolean isEmpty()
	{
		return mList.isEmpty();
	}
	
	/**
	 * 弹出第一个元素
	 * @return 元素对象
	 */
	public Object pop()
	{
		if(!isEmpty())
		{
			Object object = mList.remove(0);
			return object;		
		}
		return null;
	}
	
	/**
	 * 队列大小
	 * @return 个数
	 */
	public int size()
	{
		return mList.size();
	}
	
	/**
	 * 添加元素
	 * @param object 元素对象
	 * @return 是否添加成功
	 */
	public boolean add(Object object)
	{
		return mList.add(object);
	}
	
	/**
	 * 设置元素位置
	 * @param position 位置索引
	 * @param object 对象
	 * @return 是否设置成功
	 */
	public boolean set(int position, Object object)
	{
		return (mList.set(position, object) == null);
	}
	
	/**
	 * 清空队列
	 */
	public void clear()
	{
		mList.clear();
	}
}
